.386
.model flat,stdcall
option casemap:none

include fDataBase.inc

.code

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD

    push    hInst
    pop     hInstance
	invoke CreateClass
    mov     eax,TRUE
    ret

DllEntry Endp

;NOTE: RadASM 1.2.0.5 uses GetDef method.
;In RadASM.ini section [CustCtrl], x=CustCtrl.dll,y
;x is next free number.
;y is number of controls in the dll. In this case there is only one control.
;
;x=fDataBase.dll,1
;Copy fDataBase.dll to c:\radasm or to c:\windows\system
;
GetDef proc nInx:DWORD

	mov		eax,nInx
	.if !eax
		;Get the toolbox bitmap
		invoke LoadBitmap,hInstance,IDB_BMP
		mov		ccdef.hbmp,eax
		;Return pointer to inited struct
		mov		eax,offset ccdef
	.else
		xor		eax,eax
	.endif
	ret

GetDef endp

CreateClass proc
	LOCAL	wc:WNDCLASSEX

	;Create a windowclass for the user control
	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS or CS_PARENTDC or CS_DBLCLKS
	mov		wc.lpfnWndProc,offset ControlProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,0
	push	hInstance
	pop		wc.hInstance
	mov		wc.hbrBackground,NULL
	mov		wc.lpszMenuName,NULL
	mov		wc.lpszClassName,offset szClassName
	mov		eax,NULL
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	ret

CreateClass endp

;--------------------------------------------------------------------------------

ControlProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	ps:PAINTSTRUCT
	LOCAL	hMem:DWORD

	mov		eax,uMsg
	.if eax==WM_PAINT
		invoke BeginPaint,hWin,addr ps
		invoke CreateSolidBrush,0FF0000h
		push	eax
		invoke FillRect,ps.hdc,addr ps.rcPaint,eax
		pop		eax
		invoke DeleteObject,eax
		;Draw the caption
		invoke GetWindowTextLength,hWin
		.if eax
			inc		eax
			push	eax
			invoke GlobalAlloc,GMEM_FIXED,eax
			mov		hMem,eax
			invoke SetBkColor,ps.hdc,0FF0000h
			invoke SetTextColor,ps.hdc,0FFFFh
			pop		eax
			invoke GetWindowText,hWin,hMem,eax
			invoke SelectObject,ps.hdc,hFont
			push	eax
			invoke lstrlen,hMem
			invoke TextOut,ps.hdc,0,0,hMem,eax
			invoke GlobalFree,hMem
			pop		eax
			invoke SelectObject,ps.hdc,eax
		.endif
		invoke EndPaint,hWin,addr ps
		jmp		Ex
	.elseif eax==WM_SETFONT
		mov		eax,wParam
		mov		hFont,eax
	.endif
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
  Ex:
	ret

ControlProc endp

End DllEntry
